﻿namespace SetProperty.ViewModel
{
  using System;
  using System.ComponentModel;
  using System.Linq.Expressions;
  using System.Windows.Input;

  using SetProperty.Annotations;
  using SetProperty.Model;

  public class SetPropertyViewModel: INotifyPropertyChanged
  {
    public ICommand ClickMe { get; set; }

    public SetPropertyModel Spm {get; set; }

    public event PropertyChangedEventHandler PropertyChanged;

    public SetPropertyViewModel()
    {
      Spm = new SetPropertyModel();
      Spm.DisplayText = "test";

      ClickMe = new RelayCommand(ShowMessage);
    }

    public string DisplayText
    {
      get
      {
        return Spm.DisplayText;
      }
      set
      {
        if (Spm.DisplayText != value)
        {
          Spm.DisplayText = value;
          this.OnPropertyChanged(() => DisplayText);
        }
      }
    }

    public void MyPropertyChanged(object sender, PropertyChangedEventArgs e)
    {
      OnPropertyChanged(() => this.Spm);
    }

    private void ShowMessage()
    {
      SettingTheProperty stp = new SettingTheProperty(this);
    }

    [NotifyPropertyChangedInvocator]
    protected virtual void OnPropertyChanged<T>(Expression<Func<T>> property)
    {
      if (this.PropertyChanged != null)
      {
        var mex = property.Body as MemberExpression;
        string name = mex.Member.Name;
        this.PropertyChanged(this, new PropertyChangedEventArgs(name));
      }
    }

  }
}